routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});



// crear ruta personalizada
// cuando se ingresa a producto/listado ,
// se ejecuta el controlador ProductoController
// y dentro de este se ejecuta la funcion index
//Route::get('/producto/listado', 'ProductoController@index');


// con el middleware hacemos que antes de cada peticion llame a un componente llamado auth y que va autenticar un grupo de rutas
Route::middleware('auth')->group(function(){
	//todas las rutas que esten dentro de esta funcion va a estar autenticadas
	// crear todas las rutas para ProductoController 
	Route::resource('producto', 'ProductoController');
});



Auth::routes();

//aca podemos indicar hacia donde queremo que se rediriga una ves que ya se ha loguedao el usuario
Route::get('/home', 'HomeController@index')->name('home');

app/Producto.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

//el modelo esta vacion , pero se conecta a la tabla productos
class Producto extends Model
{	

	// para desactivar las funcionalidad que pide obligatoriamente las columnas
	//timestamp es para mantener un log de cuando se crea un registro 
	//public $timestamp = false;

    // indicamos como se une la tabla producto con categoria
	//unimos las 2 tablas , categoria con producto
	// pasa a ser una especie de join
    //metodo categoria
    public function categoria(){
    	//este producto pertenece a una categoria
    	return $this->belongsTo('App\Categoria');
    }


    // es ventas , porque el producto puede estar en mas de una venta
    //de esta forma laravel se conecta 
        public function ventas(){
    	//belongsToMany pertenece a muchas ventas
    	return $this->belongsToMany('App\Venta');
    }


}

app/Http/Controllers/ProductoController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

//importar modelos
use App\Producto;
use App\Categoria;

class ProductoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    //codigo para listas las cosas
    public function index()
    {
        //rescatar todos los productos que existen en la base de datos
        //los entrega en una lista automaticamente
        $productos = Producto::all();

        // ahora envio los datos a la vista
        // con with envio los productos
        return view('producto.index')->with('productos', $productos);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */

    // agregar un nuevo producto
    public function create()
    {
        //traemos las categorias que hay en la base de datos
        $categorias = Categoria::all();
        //mostrar el formulario vacio
        //producto.create = es el nombre de la vista
        //con esto dejamos disponible en la vista create las categorias de la bd
        return view('producto.create')->with('categorias',$categorias);
    }


    //creamos funcion para reutilizar las validacione
    public function validar(Request $request){
        //validador laravel
        //le decimos lo que queremos validar y le pasamos un array
        $this->validate($request, [
            //cuando es varchar el min se refiere a caracteres
            //unique significa que ese nombre es unico en la tabla productos y en el campo nombre
           'txtNombre' => 'required|min:3|max:20|unique:productos,nombre',
           //cuando es numeric el min se refiere a numeros
           'txtStock' => 'required|numeric|min:1',
           //exist obliga que debe existir esa categoria
           // dentro de la tabla categoria con ese id
           'cboCategoria' => 'required|exists:categorias,id',
           'txtPrecio' => 'required|numeric|min:490'

           //ejemplo de validacion fecha tipo date
           //aqui valida que la fecha sea antes del 18-02-2019
           //podriamos ocupar before:today o after:today
           //'txtFecha' => 'required|date|before:18-02-2019'
           //email
        ], [
            'txtNombre.required' => 'Campo nombre requerido',
            'txtStock.required' => 'Campo stock requerido',
            'txtNombre.min' => 'El nombre debe tener minimo 3 letras',
            'txtNombre.unique' => 'ya existe un producto con ese nombre',
            'txtStock.numeric' => 'el stock debe ser numerico'

        ]);

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */

    //guardar los productos en la base de datos
    public function store(Request $request)
    {

        //llamamos a la funcion para validar
        $this->validar($request);
        //creamos un producto
        $producto = new Producto();
        //rescatamos los datos que van llegando del formulario
        // a traves del input
        $producto->nombre = $request->get('txtNombre');
        $producto->stock = $request->get('txtStock');
        $producto->precio = $request->get('txtPrecio');
        $producto->categoria_id = $request->get('cboCategoria');

        //mensaje de error
        $mensaje = "Error al guardar";
        // preguntamos si podemos guardar esto
        //a traves del metodo save guardamos en la bd
        if ($producto->save()) {
           $mensaje = "Guardado correctamente";
        }

        // sin es guardado correctamente retornamos la lista
        //utilizamods el alias producto.index y con un mensaje guardado en la sesion
        return redirect()->route('producto.index')->with('mensaje', $mensaje);

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    // muestra los productos
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    //muestra un producto para editar
    public function edit($id)
    {
       $producto = Producto::find($id);

       if ($producto == null) {
           redirect()->route('producto.index')
                    ->with('mensaje',"Producto ya no existe");
       }

       //mandamos a la vista el producto 
       return view('producto.edit')->with('producto', $producto)
         //le mandamos las categorias para que pueda mostrarlas en el combox   
            ->with('categorias', Categoria::all());
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    // guarda el producto que se esta editando
    public function update(Request $request, $id)
    {
       $producto = Producto::find($id);

       if ($producto == null) {
           redirect()->route('producto.index')
                    ->with('mensaje',"Producto ya no existe");
       }

       //si ya existe recogemos los datos que vienen del formulario
        $producto->nombre = $request->get('txtNombre');
        $producto->stock = $request->get('txtStock');
        $producto->precio = $request->get('txtPrecio');
        $producto->categoria_id = $request->get('cboCategoria');

        //mensaje de error
        $mensaje = "Error al modificar";
        // preguntamos si podemos guardar esto
        //a traves del metodo save guardamos en la bd
        if ($producto->save()) {
           $mensaje = "Modificado correctamente";
        }

        // sin es guardado correctamente retornamos la lista
        //utilizamods el alias producto.index y con un mensaje guardado en la sesion
        return redirect()->route('producto.index')->with('mensaje', $mensaje);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    // elimina un producto
    // inyectamos automaticamente el id del producto que se va a eliminar
    public function destroy($id)
    {
        //obtenemos el producto, llamando al modelo,y mediante el metodo find()buscamos el producto
        $producto = Producto::find($id);

        //validaciones
        // si el producto ya no existe le enviamos un mensaje
        if ($producto==null) {
            return redirect()->route('producto.index')
                ->with('mensaje', "el producto ya no existe");
        }

        //antes de eliminar preguntamos si esto esta en alguna venta
        // me devuelve un arreglo de todas las ventas
        if (count($producto->ventas) > 0) {
            return redirect()->route('producto.index')
                ->with('mensaje', "Este producto ya tiene ventas asociadas");
        }

        //eliminamos un producto
        $producto->delete();

            return redirect()->route('producto.index')
                ->with('mensaje', "eliminado correctamente");

    }
}

resources/views/producto/create.blade.php
<!--reutilizamos el layout que viene con bosstrap-->
@extends('layouts.app')

<!--reescribimos todo-->
@section('content')


		<!--producto.store es el alias que se genera para 
			enviar el listado de productos-->
		<form method="post" action="{{ route('producto.store') }}">
			<!--@csrf es  para indicar que es una peticion del navegador
				y no un acceso desde un link de fuente externa-->
				@csrf
			<div class="container">
		  <div class="form-group">
			    <label for="txtNombre">Nombre</label>
			    		<!--con el value  old cada vez que guardamos queda seteado el ingreso que hicimos anteriormente
			    			con el old traemos el id que existia antes-->
			    <input type="text" class="form-control" name="txtNombre" id="txtNombre" placeholder="Ingrese su nombre" value="{{ old('txtNombre') }}">
		  </div>
		  <div class="form-group">
			    <label for="txtPrecio">Precio</label>
			    <input type="number" class="form-control" name="txtPrecio" id="txtPrecio" placeholder="Ingrese el precio">
		  </div>
		  <div class="form-group">
			    <label for="cboCategoria">Categoria</label>
			    <select  id="cboCategoria" class="form-control" name="cboCategoria">
			    	<option value="">Seleccionar</option>
	    			<!--por cada categoria hacemos un optcion-->
	    			@foreach($categorias as $categoria)
	    			<!--el value es lo que se envia cada ves que el usuario pincha-->
	    			<!--dentro de option lo que se muestra al usuario la columna de la bd-->
	    				<option value="{{ $categoria->id }}">{{ $categoria->nombre}}</option>
	    			@endforeach
			    </select>
		  </div>
		   <div class="form-group">
			    <label for="txtStock">Stock</label>
			    <input type="number" class="form-control" name="txtStock" id="txtStock" placeholder="Ingrese el stock">
		  </div>
			
		<!--campo date simulado , solo para probar un tipo date,no esta creado en bd
  		   <div class="form-group">
			    <label for="txtFecha">Date</label>
			    <input type="date" class="form-control" name="txtFecha" id="txtFecha" placeholder="Ingrese el stock">
		  </div>
		  -->

		  <input type="submit" name="btnGuardar" id="btnGuardar" class="btn btn-success" value="Guardar">
		  
		 </div>
		</form>	

@endsection

resources/views/producto/edit.blade.php
<!--reutilizamos el layout que viene con bosstrap-->
@extends('layouts.app')

<!--reescribimos todo-->
@section('content')

		<form method="post" action="{{ route('producto.update', $producto->id) }}">
			<!--@csrf es  para indicar que es una peticion del navegador
				y no un acceso desde un link de fuente externa-->
				@csrf
				@method('PUT')
			<div class="container">
		  <div class="form-group">
			    <label for="txtNombre">Nombre</label>
			    <input type="text" class="form-control" name="txtNombre" id="txtNombre" placeholder="Ingrese su nombre" value="{{ $producto->nombre }}">
		  </div>
		  <div class="form-group">
			    <label for="txtPrecio">Precio</label>
			    <input type="number" class="form-control" name="txtPrecio" id="txtPrecio" placeholder="Ingrese el precio" value="{{ $producto->precio }}">
		  </div>

		  <!--Falta rescatar categoria-->
		  <div class="form-group">
			    <label for="cboCategoria">Categoria</label>
			    <select  id="cboCategoria" class="form-control" name="cboCategoria">
			    	<option value="">Seleccionar</option>
	    			<!--por cada categoria hacemos un optcion-->
	    			@foreach($categorias as $categoria)
	    			<!--el value es lo que se envia cada ves que el usuario pincha-->
	    			<!--dentro de option lo que se muestra al usuario la columna de la bd-->
	    				<option value="{{ $categoria->id }}" {{ ($producto->categoria->id == $categoria->id) ?'selected': ''}}>{{ $categoria->nombre}}</option>
	    			@endforeach
			    </select>
		  </div>
		   <div class="form-group">
			    <label for="txtStock">Stock</label>
			    <input type="number" class="form-control" name="txtStock" id="txtStock" placeholder="Ingrese el stock" value="{{ $producto->stock }}">
		  </div>

		  <input type="submit" name="btnModificar" id="btnModificar" class="btn btn-success" value="Modificar">
		  
		 </div>
		</form>	

@endsection

resources/views/producto/index.blade.php
<!--reutilizamos el layout que viene con bosstrap-->
@extends('layouts.app')

<!--reescribimos todo-->
@section('content')



		<h2>Listado de productos</h2>

		<table class="table table-striped">
			<tr>
				<th>ID</th>
				<th>Nombre</th>
				<th>Precio</th>
				<th>Stock</th>
				<th>Categoria</th>
				<!--por cada fila que imprima existira un boton eliminar-->
				<th>Herramientas</th>
			</tr>
		<!--
		con foreach recorremos la lista,
		por cada ciclo generamos un tr
		-->
		@foreach($productos as $producto)
			<tr>
				<td>{{ $producto->id}}</td>
				<td>{{ $producto->nombre}}</td>
				<td>{{ $producto->precio}}</td>
				<td>{{ $producto->stock}}</td>
				<!--aca rescatamo el objeto categoria y desde ahi
					acceder a un atributo especifico de esta-->
				<td>{{ $producto->categoria->nombre}}</td>

				<td>
				<!--indicamos el alias producto.destroy y el id del producto a eliminar-->
					<form method="post" action="{{ route('producto.destroy', $producto->id)}}">
						<!--indicamos el metodo que entrega laravel-->
						@method('DELETE')
						<!--token de seguridad,peticion desde el navegador del usuario-->
						@csrf
						<input type="submit" name="btnEliminar" value="Eliminar">
					</form>
					<a href="{{ route('producto.edit', $producto->id) }}">Modificar</a>
				</td>
			</tr>
		@endforeach

		</table>
		<!--si en la session hay una variable mensaje
			si es asi imprimimos esa variable-->
		@if(session('mensaje'))
			{{ session('mensaje')}}
		@endif

@endsection